/* fw -- Batch from FW-Macros for THE (The Hessling Editor)
 Copyright (C) 1993-1999 Franz-Josef Wirtz

 This batch is free software; see the files README and COPYING for
 details about refusing any warranty and the GNU General Public License.

 WHAT IS IT GOOD FOR?
 Batch for using the FW-macro-set *besides* the THE-standard-installation
 This batch can be called directly to have a WordStar-like layout, or
 by the compatibiliy batches xedit.cmd, kedit.cmd or thefw.cmd to
 use FW-macros with a compatible layout to the well known ancestors.

 WHAT YOU NEED TO DO
 1. Install THE as usual, if done first time, be sure the environment
    settings are available. I.e. eventually reboot to activate changes
    in your config.sys.
 2. You should change the variable THE_FW_HOME below to the place, where
    you have installed the FW-macro-package and THE_AM_HOME for the
    AM-macros for LaTeX-keybindings. Also the variable THE_FW_FEATURES 
    maybe adjusted to your situation/preference.
 3. Copy or move this batch to a directory in your PATH-setting (or create
    an object...).
 4. Eventually add/change own settings at points marked ***

 last change: 15.Jan 1999
*/

parse arg arglist

address cmd '@echo off'

/* rem check, wether THE is minimally installed */
env = "OS2ENVIRONMENT"
the_home_dir = value( "THE_HOME_DIR",, env)

if THE_HOME_DIR == "" then
   signal _no_the_home

if stream(THE_HOME_DIR"\the.exe", "command", "query exists") == "" then
   signal _no_the_executable

/* rem backup old configuration if set in config.sys */
setlocal

HOME = value( "HOME", , env)
if (HOME = "") then
do
   say "Environment variable HOME not set, defaulting to current dir (.)"
   home = directory()
   call value "HOME", home, env
end
   
/* rem set new configuration */
fwrc_the = HOME"\fwrc.the"
fwrc_cmd = HOME"\fwrc.cmd"
no_fwrc_the = (stream( fwrc_the, "command", "query exists") == "")
no_fwrc_cmd = (stream( fwrc_cmd, "command", "query exists") == "")
if no_fwrc_the | no_fwrc_cmd then
do
   if stream( "fw.the", "command", "query exists") <> "" then
   do
      say "'the' is called for initialization of FW-macros"
      address cmd the_home_dir"\the.exe -k -p fw.the"
      say "'the' is called again for doing the original job"
   end
   else
   do
      say "Please call this script from the directory where FW-macros are installed"
      say "to get FW-macros initialized properly. Later you can use it from everywhere."
      exit
   end
end
if stream( fwrc_cmd, "command", "query exists") == "" then
do
   say fwrc_cmd "does not exist, please initialize again with macro fwmkrc"
   exit
end

"call "fwrc_cmd
the_fw_cs = value( "THE_FW_CS", , env)

/* see what we've done...;-) */
say "THE_HELP_FILE="value( "THE_HELP_FILE", , env)
say "THE_PROFILE_FILE="value( "THE_PROFILE_FILE", , env)
say "THE_FW_CS="the_fw_cs
if the_fw_cs = "ON" then
   THE_FW_CALL = "call thec.cmd"
else
   THE_FW_CALL = THE_HOME_DIR"\the.exe"

/* rem start THE with arguments */
address cmd THE_FW_CALL arglist

/* rem restore old configuration */
endlocal
exit

_no_the_home:
say "The environment variable THE_HOME_DIR is not set."
signal _the_installation

_no_the_executable:
say "The executable THE.EXE could not be found in "THE_HOME_DIR
address cmd "dir "THE_HOME_DIR
signal _the_installation

_the_installation:
say "Probably THE is not installed correctly."
say "Please refer to its documentation."
exit
