/* THEC -- THEC.CMD */
/* author:      Franz-Josef Wirtz <fw@ecotopia.oche.de>
 * copyright:   1997 to the author, who refuses *any* warranty, use at own risk
 * your right:  This batch is free software; see the file COPYING which comes
 *              with THE for the GNU General Public License.
 * operating system: OS/2, slight modifications necessary for others
 * version:     2.7a
 * purpose:     client batch to send files to queue setup by THES.CMD, to be
 *              used by editor THE (The Hessling Editor).
 *              If server is not running yet, it will be setup by
 *	        calling THES.CMD
 * restriction: No filenames with spaces allowed,
 *              No call without arguments possible (gives help instead), 
 *              except when used within FW-macros.
 *              No option switches allowed, if queue already exists. THEC will
 *              interprete *all* words passed as filenames. Nevertheless, as
 *              THEC checks, wether the files exist, in most case the option
 *              switches should simply be ignored and so do no harm.
 * environment: Usual setup of THE.
 *              Batch THES must be available in PATH.
 *              If FW-macros are installed just use fw.cmd instead, it will
 *              call thec.cmd if possible.
 */

pqhelp = 'load files to running THE via macro "PQ" (process queue)'
env = "OS2ENVIRONMENT"

the_profile_file = value( "THE_PROFILE_FILE", , env)
have_fw = (pos( "fw.the", the_profile_file ) > 0)

if (\have_fw & (arg() == 0)) then
do
   say 'client for editor THE'
   say 'pass files to be edited as space separated argument list'
   say '"THES.CMD" can be called first to directly setup server'
   say pqhelp
/*   endlocal */
   exit
end

parse arg arglist
commQ = 'THE_COMM'
queue_ok = 0 /* boolean */

/* check, wether required queue really exists */
testQ = rxqueue( 'Create', commQ) /* no rc set */
if (testQ <> commQ) then
do
   rc_del = rxqueue( 'Delete', testQ)
end
else
do
   if \have_fw then
   do
      say "communication queue not established yet"
      say 'now using "THES.CMD" instead to setup queue first'
   end
   rc_del = rxqueue( 'Delete', commQ)
   
   call thes arglist
   
   if \have_fw then
      say 'you may call "THES.CMD" directly to setup queue first'
/*   endlocal */
   exit
end   

oldQ = rxqueue( 'Set', commQ)
queue_ok = 1

i_passed = 0
do i_arg = 1 to words( arglist)
   file = word( arglist, i_arg)
   if (left( file, 1) = "-") then
   do
      say "options only allowed when starting the server"
      say "ignoring "file
      iterate
   end
   /* in case calling of THES and THEC takes place in different directories */
   fullfile = stream( file, 'command', 'query exists')
   if (fullfile <> "") then
   do
      say i_arg': passing "'fullfile'" to THE'
      queue 'edit 'fullfile
      i_passed = i_passed + 1
   end
   else
   do
      say file' not found'
      say "sorry, can't pass nonexisting files this way"
   end
end

if (queue_ok == 1) then
do
   /* restoring */
   rc_new = rxqueue( 'Set', oldQ)
end

if (i_passed > 0) then
   say pqhelp

/*   endlocal  */
